//+------------------------------------------------------------------+
//|                                       AuYeungEATRAILLINGSTOP.mq4 |
//|                                                  Copyright 2013, |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013,"

   extern double LotSize=0.01;
   extern double StopLoss=25;
   extern double TakeProfit=50;
   extern bool UseMoveToBreakeven=true;
   extern int WhenToMoveToBE=100;
   extern int pipsToLockIn=5;
   extern bool UseTrailingStop = true;
   extern int WhenToTrail=100;
   extern int TrailAmount=50;
   extern int BollingerPeriod=20;
   extern int BollingerDeviation=2;
   double pips;
   extern int MagicNumber=55667;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
      double ticksize = MarketInfo(Symbol(), MODE_TICKSIZE);
      if (ticksize == 0.00001 || ticksize == 0.001)
      pips = ticksize*10;
      else pips =ticksize;
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
      if(UseMoveToBreakeven)MoveToBreakeven();
      if(UseTrailingStop)AdjustTrail();
      if(IsNewCandle())CheckForBollingerBandTrade();
      if(IsNewCandle())CheckForStochasticTrade();
   return(0);
  }
//+------------------------------------------------------------------+         
void MoveToBreakeven()
{
   for(int b=OrdersTotal()-1; b >= 0; b--)
   {
   if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
      if(OrderMagicNumber()==MagicNumber)
         if(OrderSymbol()==Symbol())
            if(OrderType()==OP_BUY)
               if(Bid-OrderOpenPrice()>WhenToMoveToBE*pips)
                  if(OrderOpenPrice()>OrderStopLoss())
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(pipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE);
   }
for (int s=OrdersTotal()-1; s>= 0; s--)
   {
   if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
      if(OrderMagicNumber()==MagicNumber)
         if(OrderSymbol()==Symbol())
            if(OrderType()==OP_SELL)
               if(OrderOpenPrice()-Ask>WhenToMoveToBE*pips)
                  if(OrderOpenPrice()<OrderStopLoss())
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(pipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE;
   }
}
void AdjustTrail()
{
   for(int b=OrdersTotal()-1;b>=0;b--)
   {
   if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
      if(OrderMagicNumber()==MagicNumber)
         if(OrderSymbol()==Symbol())
            if(OrderType()==OP_BUY)
               if(Bid-OrderOpenPrice()>WhenToTrail*pips)
                  if(OrderStopLoss()<Bid-pips*TrailAmount)
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(pips*TrailAmount),OrderTakeProfit(),0,CLR_NONE);
   }
   for(int s=OrderTotal()-1;s>0;s--)
      {
      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()== MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELL)
                  if(OrderOpenPrice()-Ask>WhenToTrail*pips)
                     if(OrderStopLoss()>Ask+TrailAmount*pips||OrderStopLoss()==0)
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(TrailAmount*pips),OrderTakeProfit(),0,CLR_NONE);
      }
   
}                  
bool IsNewCandle()
{
   static int BarsOnChart=0;
   if (Bars == BarsOnChart)
   return (false);
   BarsOnChart = Bars;
   return(true);
}

void CheckForBollingerBandTrade()
{
   double MiddleBB=iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,0,MODE_MAIN,1);
   double LowerBB=iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,0,MODE_LOWER,1);
   double UpperBB=iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,0,MODE_UPPER,1);
   double PrevMiddleBB=iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,0,MODE_MAIN,2);
   double PrevLowerBB=iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,0,MODE_LOWER,2);
   double PrevUpperBB=iBands(NULL,0,BollingerPeriod,BollingerDeviation,0,0,MODE_UPPER,2);
      if(Close[1]<LowerBB&&Open[1]<Close[1])OrderEntry(0);
      if(Close[1]>UpperBB&&Open[1]>Close[1])OrderEntry(1);
}

//+------------------------------------------------------------------+
void CheckForStochasticTrade()
{
   double K_Line=iStochastic(NULL,0,5,3,3,0,0,MODE_MAIN,1);
   double D_Line=iStochastic(NULL,0,5,3,3,0,0,MODE_SIGNAL,1);
   double Previous_K_Line=iStochastic(NULL,0,5,3,3,0,0,MODE_MAIN,2);
   double Previous_D_Line=iStochastic(NULL,0,5,3,3,0,0,MODE_SIGNAL,2);
   if(Previous_K_Line > 80)
   if(Previous_K_Line > Previous_D_Line && K_Line < D_Line)
   OrderEntry(1);
   if(Previous_K_Line < 20)
   if(Previous_K_Line < Previous_D_Line && K_Line > D_Line)
   OrderEntry(0);
 }
 
void OrderEntry(int direction)
{
   if(direction==0)
      if(OpenOrdersThisPair(Symbol())==0)
         OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-(StopLoss*pips),Ask+(TakeProfit*pips,NULL,MagicNumber,0,Green); 
   if(direction==1)
      if(OpenOrdersThisPair(Symbol())==0)
         OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+(StopLoss*pips),Bid-(TakeProfit*pips),NULL,MagicNumber,0,Red);
}
int OpenOrdersThisPair(string pair)
{
   int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
      {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()== pair) total++;
      }
      return (total);
}

